use crate::prelude::*;

use std::os::raw::c_void;
use std::ptr;

#[repr(C)]
#[derive(Debug)]
pub struct VkBufferMemoryRequirementsInfo2 {
    pub sType: VkStructureType,
    pub pNext: *const c_void,
    pub buffer: VkBuffer,
}

impl VkBufferMemoryRequirementsInfo2 {
    pub fn new(buffer: VkBuffer) -> Self {
        VkBufferMemoryRequirementsInfo2 {
            sType: VK_STRUCTURE_TYPE_BUFFER_MEMORY_REQUIREMENTS_INFO_2,
            pNext: ptr::null(),
            buffer,
        }
    }
}
