use crate::prelude::*;

use std::os::raw::c_void;
use std::ptr;

#[repr(C)]
#[derive(Debug)]
pub struct VkPhysicalDeviceBufferDeviceAddressFeaturesEXT {
    pub sType: VkStructureType,
    pub pNext: *mut c_void,
    pub bufferDeviceAddress: VkBool32,
    pub bufferDeviceAddressCaptureReplay: VkBool32,
    pub bufferDeviceAddressMultiDevice: VkBool32,
}

impl Default for VkPhysicalDeviceBufferDeviceAddressFeaturesEXT {
    fn default() -> Self {
        VkPhysicalDeviceBufferDeviceAddressFeaturesEXT {
            sType: VK_STRUCTURE_TYPE_PHYSICAL_DEVICE_BUFFER_DEVICE_ADDRESS_FEATURES,
            pNext: ptr::null_mut(),
            bufferDeviceAddress: VK_FALSE,
            bufferDeviceAddressCaptureReplay: VK_FALSE,
            bufferDeviceAddressMultiDevice: VK_FALSE,
        }
    }
}

unsafe impl Sync for VkPhysicalDeviceBufferDeviceAddressFeaturesEXT {}
unsafe impl Send for VkPhysicalDeviceBufferDeviceAddressFeaturesEXT {}
